| Python Script Engine 8.3 GL Studio Editor Python Script API

Public Member Functions | Static Public Member Functions | List of all members
GlsKnob Class Reference
Inheritance diagram for GlsKnob:

## Public Member Functions
| GlsKnob ()
| GlsKnob (DisplayObjectArray *objs)
int | NumDetents ()
void | NumDetents (int &i)
bool | EmitDetentValEvent ()
void | EmitDetentValEvent (bool &b)
bool | EmitPositionValEvent ()
void | EmitPositionValEvent (bool &b)
bool | EmitLimitEvent ()
void | EmitLimitEvent (bool &b)
bool | EmitReleaseEvent ()
void | EmitReleaseEvent (bool &b)
bool | ShowDetentsOnly ()
void | ShowDetentsOnly (bool &b)
bool | ClickSelectsDetent ()
void | ClickSelectsDetent (bool &b)
int | DetentVal ()
void | DetentVal (int &i)
float | PositionVal ()
void | PositionVal (float &f)
int | WhichObject ()
void | WhichObject (int &i)
float | Range ()
void | Range (float &f)
bool | Continuous ()
void | Continuous (bool &b)
float | PositionOfDetent (int &pos)
void | PositionOfDetent (int &pos, float &f)
Public Member Functions inherited from Group
| Group ()
| Group (DisplayObjectArray *objs)
void | Ungroup ()
void | InsertObject (DisplayObject *obj, bool reparent=true, bool recalculateBoundingbox=true, int loc=DEFAULT_GROUP_LOCATION, bool renameName=false)
void | InsertObjectAllowDuplicateNames (DisplayObject *obj, bool reparent=true, bool recalculateBoundingbox=true, int loc=DEFAULT_GROUP_LOCATION)
void | MoveObjectToGroup (DisplayObject *obj, bool recalculateBoundingbox=true, int loc=DEFAULT_GROUP_LOCATION, bool renameName=false)
void | MoveObjectToGroupAllowDuplicateNames (DisplayObject *obj, bool recalculateBoundingbox=true, int loc=DEFAULT_GROUP_LOCATION)
void | ReorderObject (unsigned int oldIndex, unsigned int newIndex)
DisplayObjectArray * | GetObjectList ()
DisplayObject * | GetObjectByIndex (unsigned int index)
unsigned int | Count ()
void | CalculateTextureCoordinates (void)
void | SetGroupLocation (Vertex &v)
void | CalculateBoundingBox ()
unsigned int | GetCount ()
Public Member Functions inherited from DisplayObject
bool | isNULL ()
String | GetName ()
String | SetName (String name)
void | SetProtectionMode (DisplayObject::MemberAccess_e mode)
DisplayObject::MemberAccess_e | GetProtectionMode (void)
void | SetLocked (bool val)
bool | GetLocked (void)
bool | GetGenerateMemberVariable ()
void | SetGenerateMemberVariable (bool b)
bool | GetAntiAliasing ()
void | SetAntiAliasing (bool antiAliasing)
bool | GetBlinking ()
void | SetBlinking (bool blinking)
float | GetBlinkRate ()
void | SetBlinkRate (float rate)
int | GetAlphaMode ()
void | SetAlphaMode (int mode)
bool | GetCullBackFaces ()
void | SetCullBackFaces (bool cullFaces)
bool | GetZBufferTestedFlag ()
void | SetZBufferTestedFlag (bool tested)
bool | GetAffectZBufferFlag ()
void | SetAffectZBufferFlag (bool affect)
bool | GetLightingEnabledFlag ()
void | SetLightingEnabledFlag (bool enabled)
DisplayObject::PickableType_e | GetPickMode ()
void | SetPickMode (DisplayObject::PickableType_e mode)
bool | GetVisibilityFlag ()
void | SetVisibilityFlag (bool visible)
PolygonClose_e | GetClosePolygonFlag ()
void | SetClosePolygonFlag (PolygonClose_e closePolygon)
PolygonMode_e | GetPolygonMode ()
void | SetPolygonMode (PolygonMode_e polygonMode)
ShadingType_e | GetShadingMode ()
void | SetShadingMode (ShadingType_e shadingMode)
Vertex | GetLocation ()
void | SetLocation (Vertex loc)
Vertex | GetRotationPoint ()
void | SetRotationPoint (Vertex rotPoint)
GlsMatrixAffine * | GetDcsMatrix ()
void | SetDcsMatrix (GlsMatrixAffine *matrix)
int | GetMaterialIndex ()
void | SetMaterialIndex (int matIndex)
String | GetObjectClassName ()
int | GetTextureIndex ()
void | SetTextureIndex (int texIndex)
TextureMap_e | GetTextureMappingTechnique ()
void | SetTextureMappingTechnique (TextureMap_e mappingTechnique)
bool | GetTextureRepeat ()
void | SetTextureRepeat (bool repeat)
disti::GlsColor | GetBlendingColor ()
void | SetBlendingColor (GlsColor blendColor)
DisplayObject::TextureFilter_e | GetTextureMagnificationFilter ()
void | SetTextureMagnificationFilter (DisplayObject::TextureFilter_e filter)
DisplayObject::TextureFilter_e | GetTextureMinificationFilter ()
void | SetTextureMinificationFilter (DisplayObject::TextureFilter_e filter)
std::vector< Vector > | GetTextureCoordinates ()
void | SetTextureCoordinates (std::vector< Vector > &texVerts)
void | GetTextureCoordinates (VertexArray *texVerts)
void | SetTextureCoordinates (VertexArray &texVerts)
void | GetTexturePoints (VertexArray *texVerts)
void | SetTexturePoints (VertexArray &texVerts)
void | SetTexturePoints (std::vector< Vector > &texVerts)
std::vector< Vector > | GetTexturePoints ()
void | GetVertices (VertexArray *verts)
void | SetVertices (VertexArray &verts)
String | GetInitialization ()
void | SetInitialization (String initCode)
String | GetCallbackCode ()
void | SetCallbackCode (String cbCode)
DisplayObject * | DuplicateObject (Document *doc=NULL)
DisplayObject * | TessellateObject ()
DisplayObject * | ExtrudeObject (float amount)
void | RotateObject (float amount, RotationAxis_e axis)
void | TranslateObject (float x, float y, float z)
void | ScaleObject (float x, float y, float z, Vertex *anchor=NULL)
void | LineWidth (float width)
float | LineWidth ()
LineStyle_e | LineStyle ()
void | LineStyle (LineStyle_e style)
GlsColor | LineColor ()
void | LineColor (GlsColor color)
GlsColor | FillColor ()
void | FillColor (GlsColor color)
void | GetExtents (Vector &min, Vector &max)
bool | HasUserDefinedAttribute (String attribName)
std::map< String, String > | GetUserDefinedAttributes ()
UserDefinedValueAttributeList | GetAllUserDefinedAttributes ()
String | GetUserDefinedAttributeValue (String attribName)
| typemap (check) String attribName
void | SetUserDefinedAttributeValue (String attribName, String value)
DisplayObject * | GetParent ()
Document * | GetDocument ()
String | AlternateClassName ()
void | AlternateClassName (String name)
String | GetAlternateClassHeaderFile ()
void | SetAlternateClassHeaderFile (String name)
String | GetResources ()
String | GetRuntimeResources (bool recursive)
String | GetAttributeType (String attribName)
String | GetAttributeValueString (String attribName)
void | SetAttributeValueString (String attribName, String value)
unsigned int | RegisterObserver (String attribName, PyObject *pyfunc)
void | UnregisterObserver (String attribName, unsigned int id)
std::vector< Vector > | GetNormals ()
void | SetNormals (std::vector< Vector > &normals)
std::vector< CustomAttributeInfo > | GetExtraAttributes ()
DisplayObject * | CloneObject ()
void | CopyProperties (DisplayObject *sourceObj)
void | SetLocation (Vector loc)
GlsMatrixAffine | GetObjectCoordinatesTransform (DisplayObject *targetObject)
void | CalculateParentBoundingBox ()
void | SetOrigin (Vertex &vert)

## Static Public Member Functions
static GlsKnob * | CastToGlsKnob (DisplayObject *obj)
Static Public Member Functions inherited from Group
static Group * | CastToGroup (DisplayObject *obj)

## Additional Inherited Members
Public Types inherited from DisplayObject
enum | MemberAccess_e { PUBLIC , PRIVATE , PROTECTED }
enum | PickableType_e { UNPICKABLE , FIRST_PICK , BEST_PICK , ALWAYS_PICK }
enum | PolygonClose_e { POLY_OPEN , POLY_CLOSED }
enum | PolygonMode_e { POLY_MODE_UNDEFINED , POLY_MODE_POINTS , POLY_MODE_OUTLINE , POLY_MODE_FILLED , POLY_MODE_FILL_AND_OUTLINE }
enum | ShadingType_e { SHADING_FLAT , SHADING_GOURAUD }
enum | TextureMap_e { TEXTURE_MAP_MODULATE , TEXTURE_MAP_DECAL , TEXTURE_MAP_BLEND , TEXTURE_MAP_REPLACE }
enum | TextureFilter_e { TEXTURE_FILTER_NEAREST , TEXTURE_FILTER_LINEAR , TEXTURE_FILTER_NEAREST_MIPMAP_NEAREST , TEXTURE_FILTER_LINEAR_MIPMAP_LINEAR , TEXTURE_FILTER_NEAREST_MIPMAP_LINEAR , TEXTURE_FILTER_LINEAR_MIPMAP_NEAREST }
enum | TessellateType_e { TESSELLATE_UNION , TESSELLATE_INTERSECT , TESSELLATE_DIFFERENCE }
enum | RotationAxis_e { X_AXIS , Y_AXIS , Z_AXIS }
enum | LineStyle_e { SOLID_LINE_STYLE , SMALL_DOTTED_LINE_STYLE , DOTTED_LINE_STYLE , DASHED_LINE_STYLE , DOT_DASHED_LINE_STYLE , SMALL_DASHED_LINE_STYLE }
enum | AlphaMode_e { ALPHA_MODE_UNDEFINED , ALPHA_MODE_OPAQUE , ALPHA_MODE_2_LEVEL , ALPHA_MODE_256_LEVEL }
Static Public Attributes inherited from Group
static int | DEFAULT_GROUP_LOCATION = -1
Static Public Attributes inherited from DisplayObject
static int | TEXTURE_INDEX_NONE = -1

## Detailed Description

Plug-in used to create knobs in GL Studio.

## Constructor & Destructor Documentation

## ◆ GlsKnob() [1/2]

GlsKnob::GlsKnob | ( |  | ) |

Creates an empty knob.

## ◆ GlsKnob() [2/2]

GlsKnob::GlsKnob | ( | DisplayObjectArray * | objs | ) |

Creates a knob with the given children.

Parameters

  objs | objects to be added to the knob

## Member Function Documentation

## ◆ CastToGlsKnob()

static GlsKnob * GlsKnob::CastToGlsKnob | ( | DisplayObject * | obj | ) |
| static

Casts a DisplayObject to a GlsKnob.

If the given object is not a knob, it will return NULL. Should be checked for null after casting.

Parameters

  obj | Object to cast

## ◆ ClickSelectsDetent() [1/2]

bool GlsKnob::ClickSelectsDetent | ( |  | ) |

Gets whether or not clicking on a detent area will cause the knob to snap to that detent.

Returns
  bool true if clicking selects a detent, false otherwise

## ◆ ClickSelectsDetent() [2/2]

void GlsKnob::ClickSelectsDetent | ( | bool & | b | ) |

Sets whether or not clicking on a detent area should cause the knob to snap to that detent.

Parameters

  b | true to snap to detent on click, false to disable snapping on click

## ◆ Continuous() [1/2]

bool GlsKnob::Continuous | ( |  | ) |

Gets whether or not the knob is allowed to rotate in either direction for any number of turns.

Returns
  bool Returns true if knob is allowed to rotate continuously, false otherwise

## ◆ Continuous() [2/2]

void GlsKnob::Continuous | ( | bool & | b | ) |

Sets whether or not the knob is allowed to rotate in either direction for any number of turns.

Parameters

  b | true to allow knob to rotate continuously, false otherwise

## ◆ DetentVal() [1/2]

int GlsKnob::DetentVal | ( |  | ) |

Gets the current detent of the knob.

Returns
  int Current detent value

## ◆ DetentVal() [2/2]

void GlsKnob::DetentVal | ( | int & | i | ) |

Sets the detent of the knob.

Parameters

  i | New detent value

## ◆ EmitDetentValEvent() [1/2]

bool GlsKnob::EmitDetentValEvent | ( |  | ) |

Gets whether or not DetentVal events are emitted.

Returns
  bool true if event will be emitted, false otherwise

## ◆ EmitDetentValEvent() [2/2]

void GlsKnob::EmitDetentValEvent | ( | bool & | b | ) |

Sets whether or not to emit DetentVal events.

Parameters

  b | true to emit the event, false to not emit the event

## ◆ EmitLimitEvent() [1/2]

bool GlsKnob::EmitLimitEvent | ( |  | ) |

Gets whether or not Limit events are emitted.

Returns
  bool true if event will be emitted, false otherwise

## ◆ EmitLimitEvent() [2/2]

void GlsKnob::EmitLimitEvent | ( | bool & | b | ) |

Sets whether or not to emit Limit events.

Parameters

  b | true to emit the event, false to not emit the event

## ◆ EmitPositionValEvent() [1/2]

bool GlsKnob::EmitPositionValEvent | ( |  | ) |

Gets whether or not PositionVal events are emitted.

Returns
  bool true if event will be emitted, false otherwise

## ◆ EmitPositionValEvent() [2/2]

void GlsKnob::EmitPositionValEvent | ( | bool & | b | ) |

Sets whether or not to emit PositionVal events.

Parameters

  b | true to emit the event, false to not emit the event

## ◆ EmitReleaseEvent() [1/2]

bool GlsKnob::EmitReleaseEvent | ( |  | ) |

Gets whether or not Release events are emitted.

Returns
  bool true if event will be emitted, false otherwise

## ◆ EmitReleaseEvent() [2/2]

void GlsKnob::EmitReleaseEvent | ( | bool & | b | ) |

Sets whether or not to emit Release events.

Parameters

  b | true to emit the event, false to not emit the event

## ◆ NumDetents() [1/2]

int GlsKnob::NumDetents | ( |  | ) |

Gets the number of detents on the knob.

Returns
  int Number of detents

## ◆ NumDetents() [2/2]

void GlsKnob::NumDetents | ( | int & | i | ) |

Sets the number of detents on the knob.

Parameters

  i | New number of detents

## ◆ PositionOfDetent() [1/2]

float GlsKnob::PositionOfDetent | ( | int & | pos | ) |

Gets the position of the specified detent.

Returns
  float Position of detent

## ◆ PositionOfDetent() [2/2]

void GlsKnob::PositionOfDetent | ( | int & | pos,
|  | float & | f
| ) |  |

Sets the position of the specified detent.

Parameters

  pos | Detent to modify
  f | New position for detent

## ◆ PositionVal() [1/2]

float GlsKnob::PositionVal | ( |  | ) |

Gets the current position of the knob.

Returns
  float Current position value

## ◆ PositionVal() [2/2]

void GlsKnob::PositionVal | ( | float & | f | ) |

Sets the position of the knob.

Parameters

  f | New position value

## ◆ Range() [1/2]

float GlsKnob::Range | ( |  | ) |

Gets the range of rotation of the knob.

Returns
  float Current rotation range in degrees

## ◆ Range() [2/2]

void GlsKnob::Range | ( | float & | f | ) |

Sets the range of rotation of the knob.

Parameters

  f | New rotation range in degrees

## ◆ ShowDetentsOnly() [1/2]

bool GlsKnob::ShowDetentsOnly | ( |  | ) |

Gets whether or not the knob will only align with detents.

Returns
  bool true if only aligns with detents, false if allowed to align with intermediate values

## ◆ ShowDetentsOnly() [2/2]

void GlsKnob::ShowDetentsOnly | ( | bool & | b | ) |

Sets whether or not the knob will only align with detents.

Parameters

  b | true to only align with detents, false if allowed to align with intermediate values

## ◆ WhichObject() [1/2]

int GlsKnob::WhichObject | ( |  | ) |

Gets the index of the knob geometry object.

Returns
  int Current knob geometry index

## ◆ WhichObject() [2/2]

void GlsKnob::WhichObject | ( | int & | i | ) |

Sets the index of the knob geometry object.

Parameters

  i | New knob geometry index

The documentation for this class was generated from the following file:

- GlsKnob.i